#include "Normalizer.h"

// Works just like the other byTuple function but only uses elements in range 
// [start_idx,end_idx] for Normalization.
void Normalizer::byTuple( vtkFloatArray* data, vtkFloatArray* normData,
                          int start_idx, int end_idx, float min_val, float max_val ) {
   int dim = data->GetNumberOfComponents();
   int num = data->GetNumberOfTuples();

   normData->SetNumberOfComponents(dim);
   normData->SetNumberOfValues(dim * num);
   for(int i = 0; i < num; i++) {
      float min = 100000000;
      float max = -1;


      for(int j = start_idx; j <= end_idx; j++) {
        float val = data->GetValue(i * dim + j);
      
        if( val < min) {
           min = val;
        }
        if( val > max) {
           max = val;
        }
        
      }
      
      for(int j = 0; j < dim; j++) {
        float val = data->GetValue(i * dim + j);
       
        if( (j >= start_idx) && (j <= end_idx) ) {
        
           if(val == min) {
              normData->SetValue(i*dim + j, min_val);
           } else {
              normData->SetValue(i*dim + j, max_val * ((val - min)/(max - min)) );
              cout << "orig value: " << val << endl;
              cout << "new value: min = " << min << ", max = " << max << ", newval = " << max_val * ((val - min)/(max - min)) << endl;
           }
          
        } else {
           normData->SetValue(i*dim + j, val);
        }
        
      }
   }
}



void Normalizer::oneElement( vtkFloatArray* data, vtkFloatArray* normData,
                                   int idx, float min_val, float max_val ) {
   int i,j;
   float min = 1000000000;
   float max = -1;

   
   int dim = data->GetNumberOfComponents();
   int num = data->GetNumberOfTuples();
   normData->SetNumberOfComponents(dim);
   normData->SetNumberOfValues(dim * num);


   for(i = 0; i < num; i++) {
      float val = data->GetValue(i * dim + idx);
      
      if( val < min ) {
         min = val;
      } 
      if( val > max ) {
         max = val;
      }
   }

   for(i = 0; i < num; i++) {
     for(j = 0; j < dim; j++) {
        float val = data->GetValue(i * dim + j);
      
        if( j == idx ) {
          if(data->GetValue( i*dim+j ) == min) {
            normData->SetValue( i*dim+j, min_val );
          } else {
            normData->SetValue( i*dim+j, max_val * ((val - min)/(max - min)) );
          }
        } else {
          normData->SetValue( i*dim +j, val );
        }
     }
  }


}
 
void Normalizer::allElements(vtkFloatArray* data, vtkFloatArray* normData,int start_idx, int end_idx,
		           float min_val, float max_val ){
  int i,j;
   

   
   int dim = data->GetNumberOfComponents();
   int num = data->GetNumberOfTuples();
   normData->SetNumberOfComponents(dim);
   normData->SetNumberOfValues(dim * num);

  for(j = 0; j < dim; j++) {
   float min = 1000000000;
   float max = -1;
   for(i = 0; i < num; i++) {
      float val = data->GetValue(i * dim + j);
      
      if( val < min ) {
         min = val;
      } 
      if( val > max ) {
         max = val;
      }
   }

   for(i = 0; i < num; i++) {
   
        float val = data->GetValue(i * dim + j);

          if(data->GetValue( i*dim+j ) == min) {
            normData->SetValue( i*dim+j, min_val );
          } else {
            normData->SetValue( i*dim+j, max_val * ((val - min)/(max - min)) );
          }
       
     }
  }



}

void Normalizer::normAll( vtkFloatArray* data, 
                          vtkFloatArray* normData,
                          int start_idx, int end_idx,
                          float min_val, float max_val ) {
  int i =0;
  int j =0;
   float min = 1000000000;
   float max = -1;

   int dim = data->GetNumberOfComponents();
   int num = data->GetNumberOfTuples();
   normData->SetNumberOfComponents(dim);
   normData->SetNumberOfValues(dim * num);

   //   cout<< dim << " dim"<<endl;
   // cout<< num << " num"<<endl;
   

 
   
   for( i = 0; i < num; i++) {
      for( j = start_idx; j <= end_idx; j++) {
       
	   float val = data->GetValue( i*dim + j );
	
	   
	   if( val < min ) {
	     min = val;
	   }
	   if( val > max ) {
            max = val;
	   }
	 }
      }
     
      

cout << "min_val: " << min_val << endl;
cout << "max_val: " << max_val << endl;   
cout << "min: " << min << endl;
cout << "max: " << max << endl;


   for( i = 0; i < num; i++) {
      for( j = 0; j < dim; j++) {
         float val = data->GetValue( i*dim + j );
         
         if( j >= start_idx && j <= end_idx ) {
         
            if( val == min ) {
               normData->SetValue( i*dim + j, min_val );
            } else {
               normData->SetValue( i*dim + j, max_val * ((val - min)/(max - min)) );
            }

         } else {

            normData->SetValue( i*dim + j, val );

         }
      }
   }

 
}

