#include "Renderer.h"
#include "DSContainer.h"
#include "DataReader.h"
#include "Settings.h"
#include <vtkInteractorStyleTrackballCamera.h>

#include <vtkInteractorStyleFlight.h>
#include <vtkInteractorStyleUnicam.h>
#include <qframe.h>

#include <vtkCellPicker.h>
#include <vtkQtObjectFactory.h>
#include <vtkLightCollection.h>
#include <vtkLight.h>
#include "vtkMyInteractorStyleTerrain.h"
#include <vtkVectorText.h>
#include <vtkPolyDataMapper.h>
#include <vtkFollower.h>
#include <fstream>
#include <string>
#include <sstream> 
#include <vtkBMPReader.h>
#include <vtkImageActor.h>
#include <vtkCamera.h>
#include <vtkImageData.h>
#include <vtkRenderWindow.h>



using namespace std;






Renderer* Renderer::me = NULL;

float Renderer::default_height = 5;

Renderer::Renderer(QFrame* frame) {
   vtkwidget = NULL;
   ren = NULL;
   renwin = NULL;
   iren = NULL;
   ppick = NULL;

   vtkQtObjectFactory::RegisterObjectFactory();

   ren = vtkRenderer::New();	
   ren->LightFollowCameraOn();

 //  renOverview = vtkRenderer::New();
  // renOverview->LightFollowCameraOn();

  //ren->SetViewport(0.0,0.3,1.0,1.0);
  // renOverview->SetViewport(0.0,0.0,1.0,0.3);
   
   renwin = vtkRenderWindow::New();
  //renwin->SetAAFrames  ( 1);
   //renwin->LineSmoothingOn();	

   iren = vtkRenderWindowInteractor::New();

//vtkInteractorStyleTerrain * trackBallInteractorStyle = vtkInteractorStyleTerrain::New();
vtkMyInteractorStyleTerrain * trackBallInteractorStyle = vtkMyInteractorStyleTerrain::New();
//vtkInteractorStyleFlight * trackBallInteractorStyle = vtkInteractorStyleFlight::New();
//vtkInteractorStyleUnicam * trackBallInteractorStyle = vtkInteractorStyleUnicam::New();

  // vtkInteractorStyleTrackballCamera* trackBallInteractorStyle = vtkInteractorStyleTrackballCamera::New();
   iren->SetInteractorStyle(trackBallInteractorStyle);

   ppick = vtkCellPicker::New();
   iren->SetPicker( ppick );
   iren->LightFollowCameraOff();

   cout << "now building vtkwdiget" << endl;
   vtkQtObjectFactory::SetQtBase( frame, NULL );
//   renwin->SetSize(500,500);
   renwin->AddRenderer( ren );
   //renwin->AddRenderer( renOverview );
   renwin->SetInteractor( iren );
//renwin->SetNumberOfLayers(3);

   renwin->Start();
   vtkwidget = vtkQtObjectFactory::QtWidget( renwin );
   cout << "vtkwidget inited" << endl;


//vtkBMPReader* reader = vtkBMPReader::New();

  //  reader-> SetFileName ("../img/background.bmp");
   // reader-> Update();


//vtkImageActor* backGroundActor = vtkImageActor::New();
  // backGroundActor -> SetInput(reader-> GetOutput());

    
//vtkRenderer* renBackGround = vtkRenderer::New();
//renBackGround->AddActor(backGroundActor);
//renBackGround -> InteractiveOff();
//renBackGround -> SetViewport(0.0,0.3,1.0,1.0);
//renBackGround-> GetActiveCamera()-> ParallelProjectionOn();
    //fit the image to the render window
//renBackGround->GetActiveCamera()-> SetParallelScale ( reader-> GetOutput()->GetDimensions()[1]/3);
//cout<<reader-> GetOutput()->GetDimensions()[1]/2<<endl;
// renwin-> SetSize( reader-> GetOutput()->GetDimensions()[0], reader-> GetOutput()->GetDimensions()[1]);

/*renwin-> AddRenderer(renBackGround);
 renBackGround ->  SetLayer( 1);
ren->  SetLayer( 0);
*/






   ren->SetBackground( 0.1, 0.2, 0.4 );
    frame->repaint ();
   // vtkLightCollection* lights = ren->GetLights();
     /*  lights->InitTraversal ();
   vtkLight* lightTmp;
	while ( lightTmp= lights->GetNextItem()){
	  lightTmp->SetColor( 0.1, 0.2, 0.4);
	}
     */
   
   cout << "renderer background set" << endl;
   
   QSize size(300,300);
   if(vtkwidget != NULL ){
      cout << "vtkwidget is not null" << endl;
      vtkwidget->setMinimumSize( size );
   }
   
   this->mainglyph = NULL;
   this->glyphacts = NULL;
   this->paramnum = -1;
   this->glyphnum = -1;
   
   this->grid = new Grid();
   cout << "grid initialized" << endl;
   
   cout << "renderer constructor done" << endl;

   
}


Renderer::~Renderer() {
	cout<< "delete renderer"<<endl;
   delete grid;
}


Renderer* Renderer::GetMe() {
   return me;
}

void Renderer::Delete() {
   delete me;
}


Renderer* Renderer::Create(QFrame* frame) {
   if( Renderer::me == NULL ) {
      cout << "creating new renderer now" << endl;
      me = new Renderer(frame);
      cout << "done" << endl;
      return me;
   }
   
   return NULL;   
}


QWidget* Renderer::GetWidget() {
   return this->vtkwidget;
}


void Renderer::Render() {

}

void Renderer::Render( Settings* set ) {
   DSContainer* cont = DSContainer::GetMe();
   vtkFloatArray* temp1 = cont->GetDS( set->getSomDS() );

   this->default_height = set->getHeightOverSOM();

   ren->Clear();
   int numOfTuples = temp1->GetNumberOfTuples();
 /*  // ------- check for boundaries --------------------------
   for(int i = 0; i < numOfTuples; i++ ) {
      //cout << i;
      for(int j = 0; j < numOfTuples; j++ ) {
        // cout << ".";
         if( (temp1->GetValue( i* numOfTuples+ j )) > 1.0 || 
             (temp1->GetValue( i* numOfTuples+ j )) < 0.0 ) {

                for(int k = 0; k < numOfTuples; k++) {
                   if( j == set->getMapping(k) ) {
        //              cout << "k = " << k << "   j = " << j << "   map(k) = " << set->getMapping(k) << endl;
                      throw ValuesOutOfRangeException();
                   }
                }

         }
      }
   }
   // ---------------------------------------------------------

*/

   cout << "Would render following settings: " << endl;
   set->PrintSelf();   
   

   // ------------- free mainglyph from last rendering ---------
   if(mainglyph) {
      cout << "mainglyph still exists!" << endl;
      cout << "no. of actors in renderer: " << ren->VisibleActorCount() << endl;
     /* vtkActor * tmp;
      for(int i = 0; i < glyphnum; i++) {
	glyphacts[i]->InitTraversal ();
	while (tmp = glyphacts[i]->GetNextActor()){
         ren->RemoveActor(tmp );
	}
      }*/
      ren->RemoveAllProps();

      cout << "deleting old glyphs..." << endl;
     /* for( int i = 0; i < this->glyphnum; i++ ) {
         cout << i << ".." << endl;
         delete mainglyph[i];
      }
      cout << endl;
     */
      delete [] mainglyph;
      mainglyph = NULL;

      if(glyphacts) {
         free(glyphacts);
         glyphacts = NULL;
      }

   }
   cout << "everything freed" << endl;
   
  // grid->SetRenderer(NULL);
   // -------------------------------------------------------

   // temp entry until this can be set with the GUI
   GlyphWrapper::SetDefaults(
              set->getGlyphDefaults(), 
              static_cast<GlyphWrapper::glyphType>( set->getGlyphType() )
   );
   GlyphWrapper::EnableHSI( false,
                             static_cast<GlyphWrapper::glyphType>( set->getGlyphType() ) 
                          );




   // ----------------- Rendering stuff -------------------------
   switch( set->getVisType() ) {
   
     case Settings::proto:
	     init_single_glyphs(set);
	     set_som_positions(set);
        break;


     case Settings::protoWithData:
	     init_multi_glyphs(set);
	     set_som_positions(set);
        break;

      case Settings::externData:
	     renderExternData(set);
	     set_som_positions(set);
        break;

     default:
        cout << "no visualization type given!" << endl;
        break;
   
   }
   
   vtkActor * tmp;
   // build glyphs and add actors
   for(int i = 0; i < glyphnum; i++) {
      mainglyph[i]->Build();
      glyphacts[i] = mainglyph[i]->GetActors();     
      glyphacts[i]->InitTraversal ();
	while (tmp = glyphacts[i]->GetNextActor()){
	    ren->AddActor(tmp );
	}
      }  
      

   
   ren->ResetCamera();
   cout << ren->VisibleActorCount() << " actors added!" << endl;
   // ------------------------------------------------------------
   
}


void Renderer::init_single_glyphs(Settings* set) {
// TODO: change GlyphWrapper: remove single/cloud stuff, 
   DSContainer* cont = DSContainer::GetMe();
   vtkFloatArray* temparray = vtkFloatArray::New();
   
   vtkFloatArray* temp1 = cont->GetDS( set->getSomDS() );
   glyphnum = temp1->GetNumberOfTuples();
   paramnum = temp1->GetNumberOfComponents();   

   cout << "paramnum: " << paramnum << endl;
   cout << "glyphnum: " << glyphnum << endl;

   temparray->SetNumberOfComponents( paramnum );
   temparray->SetNumberOfValues( paramnum );
   
 //  mainglyph = (GlyphWrapper**)malloc(sizeof(GlyphWrapper *) * glyphnum );  
   mainglyph = new GlyphWrapper*[glyphnum];
   glyphacts = (vtkActorCollection**)malloc(sizeof(vtkActorCollection *) * glyphnum);
   
 

   for(int i = 0; i < this->glyphnum; i++) {
      for(int j = 0; j < paramnum; j++) {
         temparray->SetValue( j, temp1->GetValue( i*paramnum + j ) );
      }
      
   
	mainglyph[i] = new GlyphWrapper( 
					static_cast<GlyphWrapper::glyphType>( set->getGlyphType() ),
					temparray,
					set->getMapping(),
					false
					);
	
      
      
   }
   
   temparray->Delete();
}




void Renderer::init_multi_glyphs(Settings* set) {
   cout << "init multi!" << endl;
   DSContainer* cont = DSContainer::GetMe();
   vtkFloatArray* proto = cont->GetDS( set->getSomDS() );
   vtkFloatArray* data = cont->GetDS( set->getDataset() );
   glyphnum = proto->GetNumberOfTuples();
   paramnum = proto->GetNumberOfComponents();
   int datapnum = data->GetNumberOfComponents();
   
   cout << "set glyphnum = " << glyphnum << " and paramnum = " << paramnum << endl;


   // ------------- assign data points to prototypes -------------------------
   // prepare temporary arrays to initialize Glyphs with
   vtkFloatArray** allarrays = (vtkFloatArray**)malloc(sizeof(vtkFloatArray*) * glyphnum );
   for(int i = 0; i < glyphnum; i++) {
      allarrays[i] = vtkFloatArray::New();
      allarrays[i]->SetNumberOfComponents(datapnum);
   }
   double curdist; // current distance
   double mindist; // minimal distance
   int winneridx = -1;

  
   float* tuple;


   cout << "assign Data to nodes"<<endl;

   // index d for data, p for prototypes

   for(int d = 0; d < data->GetNumberOfTuples(); d++) {
     mindist = 100000000;
   
     for(int p = 0; p < glyphnum; p++) {

   
        curdist = 0;
        for(int i = 0; i < paramnum; i++) {
           curdist += pow(
              proto->GetTuple(p)[i] - 
              data->GetTuple(d)[i],
              2
           );
	   
        }
	
        if( curdist < mindist ) {
           mindist = curdist;
           winneridx = p;
	 
        }

     }

     // prototyp at position winneridx gets data point at position d.
     tuple = data->GetTuple(d);
     allarrays[winneridx]->InsertNextTuple(tuple); // insert whole tuple, not just mapped components

   }   
   cout << "assignments made" << endl;
   // -------------------------------------------------------------------------
   

   // initialize glyphs
   mainglyph = (GlyphWrapper**)malloc(sizeof(GlyphWrapper *) * glyphnum );
   glyphacts = (vtkActorCollection**)malloc(sizeof(vtkActorCollection *) * glyphnum );
   for(int i = 0; i < glyphnum; i++) {
     allarrays[i]->InsertNextTuple(proto->GetTuple(i));
     mainglyph[i] = new GlyphWrapper( 
       static_cast<GlyphWrapper::glyphType>( set->getGlyphType() ),
       allarrays[i],
       set->getMapping(),
       false
     );
   }

   // tidy up
    for(int i = 0; i < glyphnum; i++) {
      allarrays[i]->Delete();
   }
   free(allarrays);
   
}


void Renderer::renderExternData(Settings* set) {
   cout << "init renderExternData!" << endl;
   DSContainer* cont = DSContainer::GetMe();
   vtkFloatArray* proto = cont->GetDS( set->getSomDS() );
   vtkFloatArray* data = cont->GetDS( set->getDataset() );
   vtkFloatArray* externData = cont->GetDS( set->getMappingDataset() );
   glyphnum = proto->GetNumberOfTuples();
   paramnum = proto->GetNumberOfComponents();
   int datapnum = data->GetNumberOfComponents();
   
   cout << "set glyphnum = " << glyphnum << " and paramnum = " << paramnum << endl;


   // ------------- assign data points to prototypes -------------------------
   // prepare temporary arrays to initialize Glyphs with
   vtkFloatArray** allarrays = (vtkFloatArray**)malloc(sizeof(vtkFloatArray*) * glyphnum );
   for(int i = 0; i < glyphnum; i++) {
      allarrays[i] = vtkFloatArray::New();
      allarrays[i]->SetNumberOfComponents(datapnum);
   }
   float curdist; // current distance
   float mindist; // minimal distance 
   int winneridx = -1;

  
   float* tuple;


   cout << "assign Data to nodes"<<endl;

   // index d for data, p for prototypes

   for(int d = 0; d < data->GetNumberOfTuples(); d++) {
     mindist = 100000000;
   
     for(int p = 0; p < glyphnum; p++) {

   
        curdist = 0;
        for(int i = 0; i < paramnum; i++) {
           curdist += powf( 
              proto->GetTuple(p)[i] - 
              data->GetTuple(d)[i],
              2
           );
	   
        }
	
        if( curdist < mindist ) {
           mindist = curdist;
           winneridx = p;
	 
        }

     }

     // prototyp at position winneridx gets data point at position d.
     tuple = externData->GetTuple(d);
     allarrays[winneridx]->InsertNextTuple(tuple); // insert whole tuple, not just mapped components

   }   
   cout << "assignments made" << endl;
   // -------------------------------------------------------------------------
   

   // initialize glyphs
   mainglyph = (GlyphWrapper**)malloc(sizeof(GlyphWrapper *) * glyphnum );
   glyphacts = (vtkActorCollection**)malloc(sizeof(vtkActorCollection *) * glyphnum );
   for(int i = 0; i < glyphnum; i++) {
    
     mainglyph[i] = new GlyphWrapper( 
       static_cast<GlyphWrapper::glyphType>( set->getGlyphType() ),
       allarrays[i],
       set->getMapping(),
       false
     );
   }

   // tidy up
    for(int i = 0; i < glyphnum; i++) {
      allarrays[i]->Delete();
   }
   free(allarrays);
   
}




void Renderer::set_som_positions( Settings* set ) {
   DSContainer* cont = DSContainer::GetMe();
   
   // set som width and height
   int swidth = cont->GetSOMwidth( set->getSomDS() );
   int sheight = cont->GetSOMheight( set->getSomDS() );
   float node_dist = -1;
   float posx, posy, posz;
   posy = Renderer::default_height;
   maxrad = -1;

   cout << "setting som positions:" << endl;
   cout << "width = " << swidth << "   height = " << sheight << endl;
   

   if( set->getNodeDistance() < 0 ) {
     for( int i = 0; i < glyphnum; i++ ) {
       //  cout <<mainglyph[i]->GetMaxRadius()<<endl;
        if( node_dist < mainglyph[i]->GetMaxRadius() ) {
          node_dist = mainglyph[i]->GetMaxRadius();
          if(node_dist > maxrad) {
             maxrad = node_dist;
          }
        }
     }
     cout << "node_dist = " << node_dist << endl;
     cout << "maxRad = " << maxrad<< endl;
     node_dist *= 4;
     cout << "node_dist = " << node_dist << endl;
   } else {
      node_dist = set->getNodeDistance();
      maxrad = set->getNodeDistance();
   }
   if (maxrad > Renderer::default_height)
     this->SetDefaultHeight(((int)maxrad)+1); 

   /*
   posz = 0;
   for( int i = 0; i < sheight; i++ ) {
     posx = 0;
     for( int j = 0; j < swidth; j++ ) {
       mainglyph[ i*swidth + j ]->SetOffset( posx, posy, posz );
       cout << "settings for glyphcenter " << i*swidth + j << endl;
       cout << "x = " << posx << " | y = " << posy << " | z = " << posz << endl;
       posx += node_dist;
     }
     posz += node_dist;
   }
   cout << "SOM offsets set - ready" << endl;
   */
   // display grid
   cout << "now displaying grid..." << endl;
   grid->SetDim( swidth, sheight );
   cout << "dim set: " <<swidth<<" "<<sheight<< endl;
   grid->SetMode( set->getGridType() );
   grid->SetSOM( cont->GetDS(set->getSomDS()) );
   cout << "mode set " << endl;
   if (set->getGridType() == Settings::clustering && set->getClusterDS() !="no dataset"){
       cout << " <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<endl;
        grid->setCluster(  cont->GetDS( set->getClusterDS() ) );
  }
   grid->SetNodeDist( node_dist );
   cout << "node dist set: " <<node_dist<< endl;
   grid->SetHeight( set->getGridLeveling() );
   cout << "height set: " <<set->getGridLeveling()<< endl;



   grid->SetComponent (set->getComponent());
   cout << "grid built" << endl;

     vtkActor* tmp;
     vtkActorCollection* collect = grid->Build();
     collect  ->InitTraversal ();
     while (tmp = collect->GetNextActor()){
       ren->AddActor(tmp );
     }       


   float** hoehen = grid->getHeights();
   posz = 0;
   for( int i = 0; i < sheight; i++ ) {
     posx = 0;
     for( int j = 0; j < swidth; j++ ) {

       		mainglyph[ i*swidth + j ]->SetOffset( posx, hoehen[i][j]+Renderer::default_height, posz );
		/*vtkVectorText* text = vtkVectorText::New();
		ostringstream StrX,StrY,StrZ;
    		StrX << posx/node_dist;StrY << posy/node_dist;StrZ << posz/node_dist;
    		string pX(StrX.str());string pY(StrY.str());string pZ(StrZ.str());		
		string pos = "["+pX+","+pZ+"]";
   		const char * P = pos.c_str();
		text-> SetText (P);
    		vtkPolyDataMapper* textMapper = vtkPolyDataMapper::New();
   		textMapper->SetInput(text->GetOutput());
		vtkFollower * textActor = vtkFollower::New();
		textActor->SetMapper(textMapper);
		textActor->SetPosition(posx,posy-8,posz);
		textActor->SetScale(3.2,3.2,3.2);
		textActor->SetCamera(renOverview->GetActiveCamera());
		renOverview->AddActor(textActor);
		renOverview->ResetCamera ();
       */

	//  cout << "settings for glyphcenter " << i*swidth + j << endl;
	//cout << "x = " << posx << " | y = " << hoehen[i][j]+Renderer::default_height << " | z = " << posz << endl;
       posx += node_dist;
     }
     posz += node_dist;
   }
   cout << "SOM offsets set - ready" << endl;
}



float Renderer::GetDefaultHeight() {
   return Renderer::default_height;
}


void Renderer::SetDefaultHeight( int height ) {
   Renderer::default_height = height;
}


float Renderer::GetMaxRad() {
   return this->maxrad;
}


Grid* Renderer::GetGrid() {
   return this->grid;
}
