// Code generated by ObjectPlant

#ifndef __Gui
#define __Gui

#include "GuiDataTables.h"
#include "GuiVisSetup.h"
#include "Renderer.h"
#include <qvbox.h>
#include <qwidget.h>
#include <qstring.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qframe.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qtabwidget.h>

class Gui:  public QVBox{
Q_OBJECT

  public:
    // methods
    Gui(QWidget* parent = 0, const char* name = 0);
    ~Gui();

    // attributes
		
  signals:
    void DataSetAdded(QString dsname); // slot in GuiDataTables
    void DataSetAdded();
    void DataSetRemoved(QString dsname);

  private:
    GuiDataTables* tables;
    GuiVisSetup* setup;
//    GuiSettings*   settings;

    QWidget* vtkwidget;
    Renderer* ren;
    // data and vis are in seperate frames
    QFrame* dataFrame;
    QFrame* visFrame;
    QPushButton* start;
    
    QPopupMenu* file;	///< file menu
    QPopupMenu* ds;	///< data set menu ("DS")
    QPopupMenu* opt;	///< options menu
    QMenuBar* menu;	///< menu bar
    
    QHBoxLayout* vtklayout;
    QHBoxLayout* buttons;

    QPushButton* but1;
    QPushButton* but2;
    QPushButton* but3;
    
    QVBoxLayout* left;
    QTabWidget* tabs;
    QVBoxLayout* right;
    QHBoxLayout* central;
    QVBoxLayout* all;
    

  private slots:
    int AddDS();
    int ImportDS();
    void SaveDS();
    void RemoveDS();
    void NormalizeDS();
    void Nothing();		
    void Nothing(QString str);
   // void Start();
    void toViz();
    

};
#endif
