#include "GuiMapping.h"
#include <qframe.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qstring.h>
#include <qpainter.h>
#include <stdlib.h>
#include <iostream>
#include <qkeycode.h>
#include <qgridview.h>
#include <qwidget.h>
#include <qpalette.h>
#include <qpen.h>
#include <qtooltip.h>

using namespace std;


// ListBox -- low level drag and drop

DragList::DragList( QWidget * parent, const char * name, WFlags f ) :
    QListBox( parent, name, f )
{
    setMinimumSize(100,17*20+5);
    setMaximumSize(100,17*20+5);
    dragging = FALSE;
    //setCaption("Data Features");
}


void DragList::dragEnterEvent( QDragEnterEvent *evt )
{
    if ( QTextDrag::canDecode( evt ) ) 
	evt->accept();
}


/*void DragList::dropEvent( QDropEvent *evt )
{
    QString text;

    if ( QTextDrag::decode( evt, text ) ) 
	insertItem( text );
}
*/

void DragList::mousePressEvent( QMouseEvent *evt )
{
    QListBox::mousePressEvent( evt );
    dragging = TRUE;
}


void DragList::mouseMoveEvent( QMouseEvent * )
{
    if ( dragging ) {
	QDragObject *d = new QTextDrag( currentText(), this );
	d->dragCopy(); // do NOT delete d.
	dragging = FALSE;
    }
}


 	
	
void TableDialog::acceptInput(){
			
	table->setzeZellenInhalt(row,1,list->currentText());
	table->setzeZellenFarbe( row,1, Qt::white );			
	accept();
}
	
TableDialog::TableDialog(QWidget* parent, int dim,int row )
	:QDialog(parent,"Dialog",true,0){
		
		this->row =row;
		
		QVBoxLayout* main = new QVBoxLayout(this,2,1,"main layout");	
	  	list= new QListBox(this);
		main->addWidget(list);
		list->setMinimumSize(100,dim*20);
			//dialog-> adjustSize ();
		QString str;
		for (int i = 0; i <dim ; i++){
			list-> insertItem(str.setNum(i));
		}
		list-> insertItem(str.setNum(-1));
		
		QHBox *buttonbox = new QHBox(this);
		main->addWidget(buttonbox);
		QPushButton* abbr = new QPushButton("abbrechen",buttonbox);
		QPushButton * ok = new QPushButton("ok",buttonbox);
		
		connect( ok, SIGNAL(clicked()),
			 this, SLOT(acceptInput()) );
		connect( abbr, SIGNAL(clicked()),
			this, SLOT(reject () ));
		}
		
		




//................................................ Tableview (Konstruktor)
Tableview::Tableview(int zeilZahl, int spaltZahl, int dim,QWidget *p, const char *nam)
	: QGridView(p,nam) {
	aktZeile = aktSpalte = -1; // Aktuell ausgewaehlte Zelle
	setNumCols( spaltZahl ); setNumRows( zeilZahl ); // Spalten- und Zeilenzahl
	setCellWidth( 150 ); setCellHeight( 20 ); // Zellenbreite/-höhe in Pixel
	//resize( 600, 400 );
	inhalt = new QString[zeilZahl * spaltZahl]; // Speicher fuer Inhalt
	zellenFarbe = new QColor[zeilZahl * spaltZahl]; // Speicher fuer Farben
	this->dim =dim;
	setVScrollBarMode(AlwaysOff);
	setHScrollBarMode(AlwaysOff);		
	setAcceptDrops( TRUE );
	viewport()->setAcceptDrops(true);
	setMinimumSize(300,17*20+5);
	setMaximumSize(300,17*20+5);
	
	
	}
	
//.............................................................. paintCell
	void Tableview::paintCell( QPainter* p, int zeile, int spalte ) {
		int w = cellWidth(), h = cellHeight();
		QPen pen1;
		pen1.setColor(Qt::white);
		pen1.setStyle( DotLine );
		QPen pen2;
		pen2.setColor(Qt::black);
		pen2.setStyle( SolidLine );
		p->setPen( pen2);
		p->fillRect( 0, 0, w, h, zellenFarbe[ indexOf( zeile, spalte ) ] );
		p->drawLine(w-1, 0, w-1, h-1); p->drawLine(0, h-1, w-1, h-1); 
		if ( zeile == aktZeile && spalte == aktSpalte ) {
		
			p->setBrush ( Qt::darkBlue);			
			p->setPen( pen1);		
			p->drawText( 0, 0, w, h, AlignCenter, inhalt[indexOf(zeile,spalte)] );
			p->drawRect( 0, 0, w-1, h-1 );
			p->drawText( 0, 0, w, h, AlignCenter, inhalt[indexOf(zeile,spalte)] );
	
		} else	{
			
			p->setPen( pen2);				
			p->drawText( 0, 0, w, h, AlignCenter, inhalt[indexOf(zeile,spalte)] );
		}
		
	}
	void Tableview::resetAktSpalteZeile(){
		aktZeile = aktSpalte = -1;
	}
	void Tableview::contentsMouseDoubleClickEvent (QMouseEvent * e){
		QPoint clickedPos = viewportToContents( e->pos() );
		if (columnAt(clickedPos.x())==1){
			int row =rowAt(clickedPos.y());
			
		TableDialog* d = new TableDialog(this,dim,row);
		d->setTable(this);
		d->show();
		}
	}
	void Tableview::setDim(int dim){
		this->dim=dim;	
	}
	void Tableview::contentsDragEnterEvent(QDragEnterEvent *event)
	{	
	
			event->accept(event->provides("text/plain"));
		
	}
	void Tableview::contentsDropEvent(QDropEvent *event)
	{
		QString input;
		if (QTextDrag::decode(event, input)) {
						
			QPoint clickedPos = viewportToContents( event->pos() );
			if (columnAt(clickedPos.x())==1){
				int altZeile = aktZeile, altSpalte = aktSpalte;
				aktZeile =  rowAt(clickedPos.y());
				aktSpalte = columnAt(clickedPos.x()); 
				if ( aktZeile != altZeile || aktSpalte != altSpalte ) {
					updateCell( altZeile, altSpalte ); 
				}
				//cerr<<"input: "<<input<< " x :"<<columnAt(clickedPos.x())<<" y: "<<rowAt(clickedPos.y()) <<endl;
				
				setzeZellenInhalt( rowAt(clickedPos.y()),columnAt(clickedPos.x()),input);
				if (input =="-1"){
					setzeZellenFarbe(  rowAt(clickedPos.y()),columnAt(clickedPos.x()), Qt::gray );
				}else 
				setzeZellenFarbe(  rowAt(clickedPos.y()),columnAt(clickedPos.x()), Qt::white ); //... Zellenfarbe
				emit dropAccepted(input.toInt());
				
			}
		}
		
	}
	










GuiMapping::GuiMapping(int paramnumber, int dimension, bool defaults,
              QWidget* parent, const char* name) :QHBox(parent,name) {

	      
   	      
   this->paramnum = paramnumber;
   this->dim = dimension;
   this->mapping = NULL;
   this->defaults = defaults;
   
  // splitter = new QSplitter(this);
   QVBox *listBox = new QVBox(this);
   QLabel *listenLabel = new QLabel("Data Features",listBox);
   listenLabel->setAlignment(Qt::AlignHCenter);
   listenLabel->setFrameShadow(QFrame::Raised);
   listenLabel->setFrameShape(QFrame::StyledPanel);
   list = new DragList(listBox);
   
   tableBox = new QVBox(this);
   QLabel* tableLabel = new QLabel("Current Selected Features",tableBox);
   tableLabel->setAlignment(Qt::AlignHCenter);
   tableLabel->setFrameShadow(QFrame::Raised);
   tableLabel->setFrameShape(QFrame::StyledPanel);
   table = new Tableview(paramnum,2,0,tableBox);
  // splitter->setCollapsible(table,false);
   this->setMinimumSize(400,17*20+40);
   this->setMaximumSize(400,17*20+40);
   
   connect( table, SIGNAL(dropAccepted(int)),
	    this, SLOT(MappingChanged(int)) );

   
  // table->setAlignment(Qt::AlignHCenter);
 
   QToolTip::add( this, "Drag features from the left list to the second column of the right table" );
   
   cout << "GuiMapping constructor done" << endl;
}


GuiMapping::~GuiMapping() {

   // don't have to delete feats[i] because this is a widget,
   // it deletes its children itself.
   /*free(feats);
   cout << "freed feats (~GuiMapping)" << endl;
   free(lab);
   cout << "freed lab (~GuiMapping)" << endl;
   free(inslay);
   cout << "freed inslay (~GuiMapping)" << endl;
   */
}


void GuiMapping::update(int dim) {
   update( this->paramnum, dim );
}



void GuiMapping::update(int paramnumber, int dim) {
  cout  <<  "entering GuiMapping update method" << endl;

  
  list->clear();
  if (this->paramnum!= paramnumber){
	  Tableview* del = table;
	  table = new Tableview(paramnumber,2,dim,tableBox);
	  connect( table, SIGNAL(dropAccepted(int)),
		   this, SLOT(MappingChanged(int)) );
	  delete del;
  }
  
  QString str;
  for (int j = 0; j < paramnum ; j++){
	  table->setzeZellenInhalt(j,0,str.setNum(j));
	  table->setzeZellenFarbe( j, 0, Qt::white ); //... Zellenfarbe
	if(mapping != NULL){
 		if(mapping[j] == -1) {
	    	table->setzeZellenInhalt(j,1,"-1");
	    	table->setzeZellenFarbe( j, 1, Qt::gray ); //... Zellenfarbe
    		} else {
   		//cout << "mapping at i is " << mapping[i] << endl;
	    	table->setzeZellenInhalt(j,1,str.setNum(mapping[j]));
	    	table->setzeZellenFarbe( j,1, Qt::white ); //... Zellenfarbe
    		}
	}else{
		table->setzeZellenInhalt(j,1,"-1");
	    	table->setzeZellenFarbe( j, 1, Qt::gray ); //... Zellenfarbe
	}
	  
  }
 
  table->setDim(dim);
   
  this->paramnum = paramnumber;
  this->dim = dim;
  
 
  
  for (int i = 0; i < dim ; i++){
  	list-> insertItem(str.setNum(i));
  }
  list-> insertItem(str.setNum(-1));
 // QTableItem *item1;
  
  table->resetAktSpalteZeile();
  /*for (int j = 0; j < paramnum ; j++){
 
	  table->setzeZellenInhalt(j,0,str.setNum(j));
	  table->setzeZellenFarbe( j, 0, Qt::white ); //... Zellenfarbe
	 // table->setzeZellenInhalt(j,1,"-1");
	  //table->setzeZellenFarbe( j, 1, Qt::gray ); //... Zellenfarbe
}*/
  // mapping wird durch SetMapping Aufruf geupdatet
  
  cout << "GuiMapping update done" << endl;  
}


int GuiMapping::GetDim() {
   return this->dim;
}

void GuiMapping::SetDim(int dim) {
   this->dim = dim;
}


int GuiMapping::GetParamnum() {
   return this->paramnum;
}

void GuiMapping::SetParamnum(int paramnum) {
   this->paramnum = paramnum;
}

int GuiMapping::GetCompForFeature( int feature ) {
   if( table ) {
	   QString s = table->zellenInhalt(feature,1);
	   return s.toInt();
   } else {
      return -1;
   }
}


void GuiMapping::SetDefaultsEnabled(bool enabled) {
   this->defaults = enabled;
}

bool GuiMapping::GetDefaultsEnabled() {
   return this->defaults;
}

void GuiMapping::SetMapping( int* mapping ) {
 cout << "inside SetMapping( ... ) in GuiMapping, paramnum = " << paramnum << endl;
QString str;
this->mapping = mapping;
  for(int i = 0; i < paramnum; i++) {
	 
    if(mapping[i] == -1) {
	    table->setzeZellenInhalt(i,1,"-1");
	    table->setzeZellenFarbe( i, 1, Qt::gray ); //... Zellenfarbe
    } else {
   // cout << "mapping at i is " << mapping[i] << endl;
	    table->setzeZellenInhalt(i,1,str.setNum(mapping[i]));
	    table->setzeZellenFarbe( i,1, Qt::white ); //... Zellenfarbe
    }

  }  
}


void GuiMapping::MappingChanged(int which) {
   emit MappingChangedSig(which);
}


