#include <qhbox.h>
#include <qvbox.h>
#include <qsplitter.h>
#include <qlistbox.h>
#include <qtable.h>
#include <qstring.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qiconview.h>
#include <qgridview.h>
#include <qdialog.h>
#include <qpushbutton.h>

class QDragEnterEvent;
class QDragDropEvent;

class DragList : public QListBox

{
    Q_OBJECT
public:
    DragList( QWidget * parent = 0, const char * name = 0, WFlags f = 0 );
    // Low-level drag and drop
    void dragEnterEvent( QDragEnterEvent *evt );
   // void dropEvent( QDropEvent *evt );
    void mousePressEvent( QMouseEvent *evt );
    void mouseMoveEvent( QMouseEvent * );
private:
    int dragging;
};




class Tableview : public QGridView {
Q_OBJECT	
	public:
	Tableview( int zeilZahl, int spaltZahl, int dim,QWidget* p=0, const char* nam=0 );
	~Tableview() { delete[] inhalt; delete[] zellenFarbe;}
	const char* zellenInhalt(int z, int s) const { return inhalt[indexOf(z, s)]; }
	void setzeZellenInhalt(int z, int s, const char* c) {
		inhalt[indexOf(z, s)] = c; updateCell(z, s);
	}
	void setzeZellenFarbe(int z, int s, QColor f) {
		zellenFarbe[indexOf(z, s)] = f; updateCell(z, s);
	}
	void resetAktSpalteZeile(); 
	void setDim(int dim);
	protected:
		void paintCell( QPainter*, int zeile, int spalte );
		void contentsDragEnterEvent(QDragEnterEvent *event);
		void contentsDropEvent(QDropEvent *event);
		void contentsMouseDoubleClickEvent (QMouseEvent * e);
	signals:
		void dropAccepted(int);	
	private:
		int indexOf(int z, int s) const { return (z*numCols()) + s; }
		
	QString *inhalt, alt;
	QColor *zellenFarbe;
	int aktZeile, aktSpalte,dim;
	
};

class TableDialog : public QDialog{
	Q_OBJECT	
	
	private:
		QListBox* list;
		int result;
		int row;
		Tableview* table;
	private slots:
		void acceptInput();
			
		
	public:
		TableDialog(QWidget* parent=0, int dim=0,int row =0);			
		void setTable(Tableview* table){	
			this->table = table;	
		}
	
		
};







#ifndef __GuiMapping
#define __GuiMapping

class GuiMapping : public QHBox {
Q_OBJECT

  public:
    /// Constructor
    /**
     * Constructs <i>paramnumber</i> Labels and Combo Boxes. Each QComboBox has 
     * <i>dim</i>+1 items with numbers 0 to <i>dim</i> and -1 to choose from.
     */
    GuiMapping(int paramnumber, int dim = 0, bool defaults = true,
               QWidget* parent = 0, const char* name = 0);
               
    /// Destructor
    ~GuiMapping();
    
    /// \returns number of components current data set has
    /**
     * Takes current data set from GuiVisSetup class.
     */
    int GetDim();
    
    
    /// sets number of components current data set has
    void SetDim(int dim);
    
    /// \returns number of parameters current glyph has
    /**
     * Takes current glyph type from GuiVisSetup class.
     */
    int GetParamnum();
    
    /// sets number of parameters current glyph has
    void SetParamnum(int paramnum);
    
    /// \returns selected component/index for feature <i>feature</i> of current glyph.
    int GetCompForFeature( int feature );
    
    /// sets if there is an default entry in each combo box (-1)
    void SetDefaultsEnabled( bool enabled );
    
    /// gets bool that determines if there is an default entry in each combo box
    bool GetDefaultsEnabled();
    
    /// sets current items according to mapping
    void SetMapping(int* mapping);
    
  public slots:
     /// updates this widget according to data set dimension and <i>paramnumber</i>.
     void update(int paramnumber, int dim);

     /// updates this widget according to data set dimension.
     void update(int dim);
     
  private slots:
     void MappingChanged(int);
  
  signals:
     void MappingChangedSig(int);
  
  private:
     
    /* QComboBox** feats; ///< holds all the combo box pointers
     QHBoxLayout** inslay;
     QLabel** lab;     
     */
     DragList * list;
     Tableview* table;
     QVBox* tableBox;
     int paramnum;	///< number of combo boxes to create
	int* mapping;
     int dim;           ///< number of entries a combo box can have (dimension of data set)
     bool defaults;	///< determines if there is an entry <i>-1</i> for using a default instead of mapping something
     
     QHBoxLayout* maplay;
     QVBoxLayout* col1;
     QVBoxLayout* col2;
     QVBoxLayout* col3;


};
#endif
