#include "GuiMapping.h"
#include "Settings.h"

#include <qwidget.h>
#include <qstring.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qhbuttongroup.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qslider.h>
#include <qcheckbox.h>
#include <vector>
#ifndef __GuiVisSetup
#define __GuiVisSetup




class ComponentDialog : public QDialog{
	Q_OBJECT

	private:
		QListBox* list;
		Settings *set;
	private slots:
		void acceptInput();


	public:
		ComponentDialog(QWidget* parent=0, Settings * set=NULL);



};




class GuiVisSetup : public QWidget {
Q_OBJECT

  public:
    GuiVisSetup(QWidget* parent = 0, const char* name = 0);
    ~GuiVisSetup();
    //Settings* GetSettings(int vistype);

  signals:
	void switchToViz();


  public slots:
     void Nothing(int);
     void UpdateWidgets();
     void UpdateMapping();
     void UpdateDataSets();
     void EnableRenderButton(bool enabled = true);
     void SetMapping(int val, int idx);

  private slots:
     void gtypeChanged(int idx = 0);
     void SaveSettings();
     void LoadSettings();
     void Render();
     void MappingChanged(int);
     void AutoMapping();



     void distChanged(int);
     void heightChanged(int);
     void gridheightChanged(int);
     void detailChanged(int);
     void gridTypeChanged(int);
     void chooseComponent();


  private:

   int getSettingsIndex() ; 
	  
     vector <Settings*> set;
     static int visnum;

     QComboBox* vistype;
     QComboBox* glyphtype;

     QLabel* dslabel;
     QLabel* somlabel;
     QLabel* clusterLabel;
     QLabel* extraDataLabel;
     QComboBox* dscombo;
     QComboBox* somcombo;
     QComboBox* extraDscombo;
     QComboBox* clusterCombo;


     GuiMapping* mappingwidget;

     
     QLabel* glyphlabel;
     QLabel* vistypelabel;
     
     /// 
     QVBoxLayout* main;
     QHBoxLayout* header;
     QVBoxLayout* titles;
     QVBoxLayout* combos;
     
     ///
     QGroupBox* infogroup;
     QLabel* infolabel;
     QPixmap* infoimg;
     QLabel* pixlabel;
     
     ///
     QHBoxLayout* buttons;
     QPushButton* render;
     QPushButton* autoMapping;
     QPushButton* save;
     QPushButton* load;
     

     ///
     QGroupBox* addgroup;
     QFrame* addframe;
     QGridLayout* addlay;

     QLabel* distlab;
     QSlider* distline;
    // QDoubleValidator* doubvald;

     QLabel* heightlab;
     QSlider* heightline;
     //QDoubleValidator* doubvalh;
     
     QLabel* umatlab;
     QSlider* umatline;
     
     QSlider* detail;
    // QSlider* slidmax;


     

};
#endif

