#include <qlistview.h>

#ifndef __MyListViewItem
#define __MyListViewItem


/// This class extends QListViewItem to sort numerically.
class MyListViewItem : public QListViewItem {
  public:
     
     /// Constructor
     MyListViewItem(QListView* parent);
     
     /// compares float values of strings inside QListViewItems
     /**
      * \returns -1 if this items string is lower than <i>i</i>, 
      * 0 if they are equal, 1 else.
      *
      * \param i QListViewItem to compare this item to
      * \param col column of QListViewItem to use for sorting.
      * \param ascending not used (like recommended by the qt api documentation).
      */
     int compare( QListViewItem* i, int col, bool ascending ) const;    

};
#endif
