// vtkPolyDataNoDeepCopyProb.cpp: Implementierung der Klasse vtkPolyDataNoDeepCopyProb.
//
//////////////////////////////////////////////////////////////////////

#include <vtkObjectFactory.h>
#include <vtkCellArray.h>
#include "vtkPolyDataNoDeepCopyProb.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

vtkPolyDataNoDeepCopyProb::vtkPolyDataNoDeepCopyProb()
{
	
}

vtkPolyDataNoDeepCopyProb::~vtkPolyDataNoDeepCopyProb()
{
	
}


vtkPolyDataNoDeepCopyProb *
vtkPolyDataNoDeepCopyProb::New()
{
	// First try to create the object from the vtkObjectFactory
	vtkObject* ret = vtkObjectFactory::CreateInstance("vtkPolyDataNoDeepCopyProb");
	if(ret)
    {
		return (vtkPolyDataNoDeepCopyProb*)ret;
    }
	// If the factory was unable to create the object, then create it here.
	return new vtkPolyDataNoDeepCopyProb;
}


void 
vtkPolyDataNoDeepCopyProb::PrintSelf(ostream& os, vtkIndent indent)
{
	vtkPolyData::PrintSelf(os, indent);
}


void 
vtkPolyDataNoDeepCopyProb::DeepCopy(vtkDataObject *dataObject)
{
	vtkPolyData *polyData = vtkPolyData::SafeDownCast(dataObject);
	
	if ( polyData != NULL )
    {
		vtkCellArray *ca;
		ca = vtkCellArray::New();
		ca->DeepCopy(polyData->GetVerts());
		this->SetVerts(ca);
		ca->Delete();
		
		ca = vtkCellArray::New();
		ca->DeepCopy(polyData->GetLines());
		this->SetLines(ca);
		ca->Delete();
		
		ca = vtkCellArray::New();
		ca->DeepCopy(polyData->GetPolys());
		this->SetPolys(ca);
		ca->Delete();
		
		ca = vtkCellArray::New();
		ca->DeepCopy(polyData->GetStrips());
		this->SetStrips(ca);
		ca->Delete();
		
		// Do super-superclass
		this->vtkPointSet::DeepCopy(dataObject);
		
		if ( this->Cells )
		{
			this->Cells->UnRegister(this);
			this->Cells = NULL;
		}
/*		if (polyData->Cells)
		{
			this->BuildCells();
		}*/
		
		if ( this->Links )
		{
			this->Links->UnRegister(this);
			this->Links = NULL;
		}
/*		if (polyData->Links)
		{
			this->BuildLinks();
		}*/
    }
}