/*=========================================================================

  Program:   Visualization Toolkit
  Module:    $RCSfile: vtkOpenGLLight.h,v $
  Language:  C++
  Date:      $Date: 2002/08/22 18:39:31 $
  Version:   $Revision: 1.18 $

  Copyright (c) 1993-2002 Ken Martin, Will Schroeder, Bill Lorensen
  All rights reserved.
  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
// .NAME vtkOpenGLLight - OpenGL light
// .SECTION Description
// vtkOpenGLLight is a concrete implementation of the abstract class vtkLight.
// vtkOpenGLLight interfaces to the OpenGL rendering library.

#ifndef __vtkQGLLight_h
#define __vtkQGLLight_h

#include <vtkOpenGLLight.h>

class vtkOpenGLRenderer;

class vtkQGLLight : public vtkOpenGLLight
{
public:
  static vtkQGLLight *New();
  vtkTypeRevisionMacro(vtkQGLLight,vtkOpenGLLight);

  // Description:
  // Implement base class method.
  void Render(vtkRenderer *ren,int light_index);

protected:
  vtkQGLLight() {};
  ~vtkQGLLight() {};
private:
  vtkQGLLight(const vtkQGLLight&);  // Not implemented.
  void operator=(const vtkQGLLight&);  // Not implemented.
};

#endif

