#ifndef vtkQGLRenderWindow_h
#define vtkQGLRenderWindow_h

#include <stdlib.h>
#include <vtkOpenGLRenderWindow.h>

#if defined(WIN32)
	#include <windows.h>
#endif

#include "vtkQGLPtrToQT.h"
#include "vtkQGLWindowQT.h"


class vtkQGLRenderWindowQT;

class vtkQGLRenderWindow : public vtkOpenGLRenderWindow, public vtkQGLPtrToQT
{
public:
	/* ------------------------------------------------------------
	* Methods from vtkRenderWindow class.
	*/
	static vtkQGLRenderWindow *New()
	{
		return new vtkQGLRenderWindow() ;
	};

	vtkTypeMacro(vtkQGLRenderWindow, vtkOpenGLRenderWindow);

	void PrintSelf(ostream& os, vtkIndent indent);

	virtual void Start(void);
	virtual void Frame(void);
	void WindowInitialize(void);
	virtual void SetFullScreen(int);
	virtual void WindowRemap(void);
	void PrefFullScreen(void);
	void SetSize(int,int);
	void SetSizeSuper(int w,int h);
	void HideCursor(){/*Todo*/};
	void ShowCursor(){/*Todo*/};
	int GetEventPending(){return 0;/*Todo*/};

	virtual void MakeCurrent();


	virtual void Render(void);
	virtual void RenderSuper(void){vtkOpenGLRenderWindow::Render();};


	// Return NULL if Start wasn't called!!! Display errormessage
	virtual QWidget* GetQTPtr();

	// Description:
	virtual void SetDisplayId(void *) {}
	virtual void SetWindowId(void *)  {}
	virtual void SetParentId(void *)  {}
	virtual void *GetGenericDisplayId();
	virtual void *GetGenericWindowId();
	virtual void *GetGenericParentId();
	virtual void *GetGenericContext();
	virtual void *GetGenericDrawable();
	virtual void SetWindowInfo(char *) {}
	virtual void SetParentInfo(char *) {}

	virtual int  GetStereoCapableWindow();

	virtual void StereoMidpoint();
	virtual void StereoRenderComplete();


protected:
  vtkQGLRenderWindow();
  ~vtkQGLRenderWindow() ;
  vtkQGLRenderWindow(const vtkQGLRenderWindow&) { }
  void operator=(const vtkQGLRenderWindow&) { }

  vtkQGLRenderWindowQT *mMyQTWidget;
  vtkIdList *TextureResourceIds;

#if defined(WIN32)
	HWND hLastWinId;
	HDC  hLastDC;
#endif
};



class vtkQGLRenderWindowQT : public vtkQGLWindowQT
{
public:
	vtkQGLRenderWindowQT(const QGLFormat & format, QWidget *parent, const char *name, const QGLWidget *shared):
		vtkQGLWindowQT(format, parent, name, shared)
	{
	};

	virtual void paintGL()
	{
		vtkQGLRenderWindow *window = (vtkQGLRenderWindow*)this->GetVTKPtr();
		window->RenderSuper();
		vtkQGLWindowQT::paintGL();
	}

	virtual void resizeGL(int w, int h)
	{
		vtkQGLWindowQT::resizeGL(w, h);
		vtkQGLRenderWindow *window = (vtkQGLRenderWindow*)this->GetVTKPtr();
		window->SetSizeSuper(w, h);
	}
};


#endif
