// vtkQGLWindowQT.h: Schnittstelle fr die Klasse vtkQGLWindowQT.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VTKQGLWINDOWQT_H__4AFFBE23_8FB3_11D5_BA43_00105AEFC335__INCLUDED_)
#define AFX_VTKQGLWINDOWQT_H__4AFFBE23_8FB3_11D5_BA43_00105AEFC335__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <qgl.h>
#include "vtkQGLPtrToVTK.h"


class vtkQGLWindowQT : public QGLWidget, public vtkQGLPtrToVTK
{
  Q_OBJECT 

public:
  vtkQGLWindowQT(const QGLFormat & format, QWidget *parent, const char *name, const QGLWidget *shared);

  void Frame(void);
  void SetSize(int w, int h);

  /* ------------------------------------------------------------
   * Methods from QGLWidget class. 
   */
  virtual QSize       sizeHint() const;

  virtual void setSizeHint(const QSize size);


protected:
  /* ------------------------------------------------------------
   * Methods from QGLWidget class. 
   */
//  virtual void initializeGL() ;
//  virtual void paintGL() ;
//  virtual void resizeGL(int w, int h) ;
  virtual void mouseMoveEvent( QMouseEvent * ) ;
  virtual void mousePressEvent( QMouseEvent * ) ;
  virtual void mouseReleaseEvent( QMouseEvent * ) ;
  virtual void keyPressEvent( QKeyEvent * ) ;
  virtual void keyReleaseEvent( QKeyEvent * ) ;
  //
  // Every focus-in and focus-out event results in a repaint 
  // through the default implementations of focusInEvent and
  // focusOutEvent. This results in a flicker in the vtkQGLRenderWindow
  // ever time the cursor moves in or out of the widget. We can 
  // disble this by calling repaint(FALSE) in the implementation
  // of these methods. 
  //
  virtual void focusInEvent( QFocusEvent * ) { repaint(FALSE) ; }
  virtual void focusOutEvent( QFocusEvent * ) { repaint(FALSE) ; }
  //
  // If this widget is not the top level widget, it does not 
  // get focus until it receives its first mouse click. By 
  // overloading the enterEvent and leaveEvent methods, we 
  // give keyboard focus to the widget when the mouse enters
  // and remove the focus once the mouse leaves. 
  //
  virtual void enterEvent( QEvent * ) { setFocus() ; }
  virtual void leaveEvent( QEvent * ) { clearFocus() ; }


  QSize renderWindowSizeHint;


  /* ------------------------------------------------------------
   * A few signals which will help us write an interactor for this
   * render window. 
   */
  signals:
  //
  // Mouse moved. 
  //
  void MouseMove(const QMouseEvent *event) ;
  //
  // Left button pressed/released at the specified location.
  //
  void LeftButtonPressed(const QMouseEvent *event) ;
  void LeftButtonReleased(const QMouseEvent *event) ;
  //
  // Middle button pressed/released at the specified location.
  //
  void MiddleButtonPressed(const QMouseEvent *event) ;
  void MiddleButtonReleased(const QMouseEvent *event) ;
  //
  // Right button pressed/released at the specified location.
  //
  void RightButtonPressed(const QMouseEvent *event) ;
  void RightButtonReleased(const QMouseEvent *event) ;
  //
  // Any mouse button pressed.
  //
  // void ButtonPressed(const QMouseEvent *event) ;
  // void ButtonReleased(const QMouseEvent *event) ;
  //
  // Any key pressed.
  //
  void KeyPressed(QKeyEvent *event) ;
  void KeyReleased(QKeyEvent *event) ;

public:
  static vtkQGLWindowQT *mCurrentWidget;
};


#endif // !defined(AFX_VTKQGLWINDOWQT_H__4AFFBE23_8FB3_11D5_BA43_00105AEFC335__INCLUDED_)
