#include "vtkQtOutputWindow.h"
#include "vtkQtObjectFactory.h"

#include "moc_vtkQtOutputWindow.cpp"

vtkQtOutputWindow::vtkQtOutputWindow(QWidget* widgetParent, char* widgetName)
{
	vtkQGLQMultiLineEdit *messageBox = new vtkQGLQMultiLineEdit(widgetParent, widgetName);
	messageBox->SetVTKPtr(this);
	this->SetQTPtr(messageBox);

	messageBox->setReadOnly(true);
}

vtkQtOutputWindow::~vtkQtOutputWindow()
{
	delete this->GetQTPtr();
}

// default implementation outputs to cerr only
void vtkQtOutputWindow::DisplayText(const char* txt)
{
	QMultiLineEdit *messageBox = (QMultiLineEdit*)this->GetQTPtr();
	messageBox->insertLine(txt, -1);
	messageBox->setCursorPosition (messageBox->numLines (), 0, FALSE);
}

// Up the reference count so it behaves like New
vtkQtOutputWindow* vtkQtOutputWindow::New(QWidget* widgetParent, char* widgetName)
{
	// First try to create the object from the vtkObjectFactory
	vtkQtObjectFactory::SetQtBase(widgetParent, widgetName);
	vtkObject* ret = vtkObjectFactory::CreateInstance("vtkQtOutputWindow");
	vtkQtObjectFactory::SetQtBase(NULL, NULL);
	if(ret)
	{
		return (vtkQtOutputWindow*)ret;
	}
	// If the factory was unable to create the object, then create it here.
	return new vtkQtOutputWindow(widgetParent, widgetName);
}


// Return the single instance of the vtkQtOutputWindow
vtkObject *vtkQtOutputWindow::UseQtWidget(QWidget* widgetParent, char* widgetName)
{
	vtkOutputWindow *newInstance = vtkQtOutputWindow::New(widgetParent, widgetName);
	vtkOutputWindow::SetInstance(newInstance);

	return newInstance;
}

