#ifndef __vtkQtOutputWindow_h
#define __vtkQtOutputWindow_h

#include <vtkOutputWindow.h>
#include <qwidget.h>
#include <qmultilineedit.h>
#include "vtkQGLPtrToQT.h"
#include "vtkQGLPtrToVTK.h"

class vtkQGLQMultiLineEdit;


class vtkQtOutputWindow : public vtkOutputWindow, public vtkQGLPtrToQT
{
public:
	// Methods from vtkObject
	vtkTypeMacro(vtkQtOutputWindow, vtkOutputWindow);

	// Description:
	static vtkQtOutputWindow* New() { return vtkQtOutputWindow::New(NULL, NULL);};
	static vtkQtOutputWindow* New(QWidget* widgetParent, char* widgetName);

	// Description:
	static vtkObject *UseQtWidget(QWidget* widgetParent, char* widgetName);

	//
	virtual void DisplayText(const char*);


protected:
	vtkQtOutputWindow(QWidget* widgetParent, char* widgetName);
	virtual ~vtkQtOutputWindow();

	vtkQtOutputWindow(const vtkQtOutputWindow&) {};
	void operator=(const vtkQtOutputWindow&) {};
};


class vtkQGLQMultiLineEdit : public QMultiLineEdit, public vtkQGLPtrToVTK
{
  Q_OBJECT 

public:
	vtkQGLQMultiLineEdit(QWidget *parent, const char *name):QMultiLineEdit(parent,name){};
	~vtkQGLQMultiLineEdit(){};
};

#endif
